import java.awt.Dimension;

public class BFS extends SearchEngine {

	public BFS(EnhancedBoard board,int x,int y,int x2, int y2) {
        super(board, x, y, x2, y2);
        doSearchOnBoard();
    }

    private void doSearchOnBoard() {
        int width = theboard.getWidth();
        int height = theboard.getHeight();
        boolean alReadyVisitedFlag[][] = new boolean[width][height];

        Dimension predecessor[][] = new Dimension[width][height];
        DimensionQueue queue = new DimensionQueue();

        for (int i=0; i<width; i++) {
            for (int j=0; j<height; j++) {
                alReadyVisitedFlag[i][j] = false;

                predecessor[i][j] = null;
            }
        }

        alReadyVisitedFlag[startLoc.width][startLoc.height] = true;

        queue.addToBackOfQueue(startLoc);
        boolean success = false;
    outer:      
        while (queue.isEmpty() == false) {
            Dimension head = queue.peekAtFrontOfQueue();
            if (head == null) break; // ??
            Dimension [] connected = getAdjacentMoves(head);
            for (int i=0; i<8; i++) {
                if (connected[i] == null) break;
                int w = connected[i].width;
                int h = connected[i].height;
                if (alReadyVisitedFlag[w][h] == false) {
                    alReadyVisitedFlag[w][h] = true;
                    predecessor[w][h] = head;
                    queue.addToBackOfQueue(connected[i]);
                    if (equals(connected[i], goalLoc)) {
                        success = true;
                        break outer; // we are done
                    }
                }
            }
            queue.removeFromFrontOfQueue(); // ignore return value
        }
        // now calculate the shortest path from the predecessor array:
        maxDepth = 0;
        if (success) {
            searchPath[maxDepth++] = goalLoc;
            for (int i=0; i<100; i++) {
                searchPath[maxDepth] = predecessor[searchPath[maxDepth - 1].width][searchPath[maxDepth - 1].height];
                maxDepth++;
                if (equals(searchPath[maxDepth - 1], startLoc))  break;  // back to starting node
            }
        }
    }
    protected class DimensionQueue {
        public DimensionQueue(int num) {
            queue = new Dimension[num];
            head = tail = 0;
            len = num;
        }
        public DimensionQueue() {
            this(400);
        }
        public void addToBackOfQueue(Dimension n) {
            queue[tail] = n;
            if (tail >= (len - 1)) {
                tail = 0;
            } else {
                tail++;
            }
        }
        public Dimension removeFromFrontOfQueue() {
            Dimension ret = queue[head];
            if (head >= (len - 1)) {
                head = 0;
            } else {
                head++;
            }
            return ret;
        }
        public boolean isEmpty() {
            return head == (tail + 1);
        }
        public Dimension peekAtFrontOfQueue() {
            return queue[head];
        }       
        private Dimension [] queue;
        private int tail, head, len;
    }
}
