import java.awt.Dimension;
import java.util.LinkedList;

public class Brain 
{
	private Dimension nextmove=new Dimension();
	private Dimension[] AvailableMoves, AvailableShots;
	private LinkedList<Dimension> queenOrder,EnemyQueenOrder,EnemyNeighbors, EnemyAdjOpenPositions;
	public int neighborlogic=0, defenselogic=0, defaultlogic=0, offensiveLogic=0, offensiveNeighborLogic=0;
    public static final int CONSERVATIVENESS = 15; // How defensive the player is
	
	public Brain()
	{ }	

	public Dimension[] calculateMove()
	{
		Dimension[] moveToReturn= new Dimension[2];
		int neighborcount=0;
		queenOrder= sortByOpenness(MartyMcfly.OurQueens);
		// If a Queen has 0 move remove it from queue and set it blocked
        for (int i=0; i < queenOrder.size(); i++) 
        {
        	if(queenOrder.get(i).height ==0)
        	{ MartyMcfly.OurQueens[queenOrder.get(i).width].setBlocked(); }
        }
        
		EnemyQueenOrder= sortByNeighbors(MartyMcfly.EnemyQueens);
		  
        for (int i=0; i < EnemyQueenOrder.size(); i++) 
        {
        	if(EnemyQueenOrder.get(i).height ==0)
        	{ MartyMcfly.EnemyQueens[EnemyQueenOrder.get(i).width].setBlocked(); }
        }
	
        //Defensive: Basic Neighbor Check (Move Queens that are about to be closed in
        
        for (int i=0; i<queenOrder.size(); i++) 
        {
        	if(!MartyMcfly.OurQueens[queenOrder.get(i).width].isBlocked()){ 
        		neighborcount=MartyMcfly.OurQueens[queenOrder.get(i).width].neighbors();
        		if( neighborcount > 6){
            		nextmove = MartyMcfly.OurQueens[queenOrder.get(i).width].getBestMove();
        			if (neighborcount > MartyMcfly.masterboard.neighbors(nextmove.width, nextmove.height)){
        				moveToReturn[0]= MartyMcfly.OurQueens[queenOrder.get(i).width].getpos();
                		moveToReturn[1]= nextmove;
                		neighborlogic++;
                		MartyMcfly.OurQueens[queenOrder.get(i).width].moveto(nextmove.width, nextmove.height);
                		return moveToReturn;
        			}
        		}
        	}	
        }

        //Offensive: Check if Any Enemy Queen is one move away from being closed in (A similiar search is done later, but for all queens)
		EnemyAdjOpenPositions= new LinkedList<Dimension>();
        for (int i= EnemyQueenOrder.size()-1; i >= 0; i--) 
        {
        	if(MartyMcfly.EnemyQueens[EnemyQueenOrder.get(i).width].neighbors() == 7)
        	{
        	EnemyNeighbors=MartyMcfly.EnemyQueens[EnemyQueenOrder.get(i).width].adjacentOpenPositions();
        	
        	for (int j=0; j<EnemyNeighbors.size(); j++)
        	{ EnemyAdjOpenPositions.add(EnemyNeighbors.get(j)); }
        	}
        }
        
        if (EnemyAdjOpenPositions.size() > 0)
        {    
        	for (int i=0; i<queenOrder.size(); i++) {
        		if(!MartyMcfly.OurQueens[queenOrder.get(i).width].isBlocked()){ 
        			AvailableMoves= MartyMcfly.OurQueens[queenOrder.get(i).width].availableMoves();        		
        	
        	for (int j=0; j < AvailableMoves.length; j++) 
        	{
        		AvailableShots= MartyMcfly.masterboard.availableMovesFrom(AvailableMoves[j].width, AvailableMoves[j].height );
        		for (int k=0; k < AvailableShots.length; k++) {
            		if(EnemyAdjOpenPositions.contains(AvailableShots[k])){
            			// Return the Move and Assume that our calculate shot function will pick it up
            			System.out.println("Trying to move "+MartyMcfly.OurQueens[queenOrder.get(i).width].getpos().width+","+MartyMcfly.OurQueens[queenOrder.get(i).width].getpos().height+" to "+AvailableMoves[j].width+","+ AvailableMoves[j].height+"to take shot: "+AvailableShots[k].width+","+AvailableShots[k].height );            			
        				moveToReturn[0]= MartyMcfly.OurQueens[queenOrder.get(i).width].getpos();
                		moveToReturn[1]= nextmove=AvailableMoves[j];
                		offensiveNeighborLogic++;
                		MartyMcfly.OurQueens[queenOrder.get(i).width].moveto(nextmove.width, nextmove.height);
                		return moveToReturn;            			
            		}
      	     	}
        	}
        		}
        	}
        }     
        
        
		//Defensive: Check for Enclosure Danger
        for (int i=0; i<queenOrder.size(); i++) 
        {
        	if(!MartyMcfly.OurQueens[queenOrder.get(i).width].isBlocked() && queenOrder.get(i).height < CONSERVATIVENESS){
        		int queenKey= queenOrder.get(i).width;
        		moveToReturn[0]= MartyMcfly.OurQueens[queenKey].getpos();
        		moveToReturn[1]= nextmove = MartyMcfly.OurQueens[queenKey].getBestMove();
        	
        		System.out.println("Queen at--> "+MartyMcfly.OurQueens[queenKey].getpos().width+","+MartyMcfly.OurQueens[queenKey].getpos().height+" and blocked:"+MartyMcfly.OurQueens[queenKey].isBlocked());
        		
        		System.out.println("Getting Best Move for: "+queenKey+" which has openness of:"+ MartyMcfly.OurQueens[queenKey].openness()+" and" +MartyMcfly.OurQueens[queenKey].openness());
        		System.out.println("Moving: Q"+queenOrder.get(i).width+" to "+nextmove.width+", "+nextmove.height);
        		MartyMcfly.OurQueens[queenOrder.get(i).width].moveto(nextmove.width, nextmove.height);
        		defenselogic++;
        		 return moveToReturn;
        	}           
        }
        
        
		//Offensive:
		EnemyAdjOpenPositions= new LinkedList<Dimension>();
        for (int i= EnemyQueenOrder.size()-1; i >= 0; i--) 
        {
        	EnemyNeighbors=MartyMcfly.EnemyQueens[EnemyQueenOrder.get(i).width].adjacentOpenPositions();
        	
        	for (int j=0; j<EnemyNeighbors.size(); j++)
        	{ EnemyAdjOpenPositions.add(EnemyNeighbors.get(j)); }
        }
        //Since we have all the vulnerable position of our enemies, lets see if our Queen has a shot at one of them...
        // This is a pretty Exhaustive search
        
        
        for (int i=0; i<queenOrder.size(); i++) 
        {
        	if(!MartyMcfly.OurQueens[queenOrder.get(i).width].isBlocked()){ 
            	AvailableMoves= MartyMcfly.OurQueens[queenOrder.get(i).width].availableMoves();        		
        	
        	for (int j=0; j < AvailableMoves.length; j++) 
        	{
        		AvailableShots= MartyMcfly.masterboard.availableMovesFrom(AvailableMoves[j].width, AvailableMoves[j].height );
            	for (int k=0; k < AvailableShots.length; k++) {
            		if(EnemyAdjOpenPositions.contains(AvailableShots[k]))
            		{
            			// Return the Move and Assume that our calculate shot function will pick it up
            			System.out.println("Trying to move "+MartyMcfly.OurQueens[queenOrder.get(i).width].getpos().width+","+MartyMcfly.OurQueens[queenOrder.get(i).width].getpos().height+" to "+AvailableMoves[j].width+","+ AvailableMoves[j].height+"to take shot: "+AvailableShots[k].width+","+AvailableShots[k].height );            			
        				moveToReturn[0]= MartyMcfly.OurQueens[queenOrder.get(i).width].getpos();
                		moveToReturn[1]= nextmove=AvailableMoves[j];
                		offensiveLogic++;
                		MartyMcfly.OurQueens[queenOrder.get(i).width].moveto(nextmove.width, nextmove.height);
                		return moveToReturn;            			
            		}
            	}
        	}
        	}
        	
        }
       
        // Survival
        // This is what the BFS was coded for, however, it seems this AI works probably better without it
        // Default Logic: OKAY! There are no obvious moves to take. So, move The queen to any spot
        int queenKey=-1;
        for (int i=0; i < queenOrder.size(); i++) 
        {
        	if(queenOrder.get(i).height > 0)
        	{
        		queenKey= queenOrder.get(i).width;
        		System.out.println("Found Not blocked:"+ queenKey);
        		System.out.println("at:"+ MartyMcfly.OurQueens[0].getpos().width+","+MartyMcfly.OurQueens[queenKey].getpos().height);        		
        		System.out.println("t/f:" + MartyMcfly.OurQueens[0].isBlocked());
        		break;
        	}
        }
     
        if(queenKey==-1)
        {
        	System.out.println("Brain.CalculateMove: No Queens can move. The Game maybe over. Exiting.");
        	//System.exit(1);
        	return null;
        }
		moveToReturn[0]= MartyMcfly.OurQueens[queenKey].getpos();
        System.out.println("at:"+ moveToReturn[0].width+","+moveToReturn[0].height);
        
		moveToReturn[1]= nextmove = MartyMcfly.OurQueens[queenKey].getBestMove();
		MartyMcfly.OurQueens[queenKey].moveto(moveToReturn[1].width, moveToReturn[1].height);
		System.out.println("Moving: Q"+queenKey+" to " +moveToReturn[1].width+", "+moveToReturn[1].height);     

        defaultlogic++;
        return moveToReturn;
	}
	
	public Dimension calculateShotFrom(Dimension[] moveVector){
		int queenKey;
		LinkedList<Integer> cleanup= new LinkedList<Integer>();
		
		LinkedList<Dimension> adjacentCoordinates;
		Dimension[] availableShots;
		
		EnemyQueenOrder= sortByNeighbors(MartyMcfly.EnemyQueens);
		// If a Queen has 0 move remove it from queue and set it blocked
        for (int i=0; i < EnemyQueenOrder.size(); i++)
        {
        	if(EnemyQueenOrder.get(i).height ==0){
        		MartyMcfly.EnemyQueens[EnemyQueenOrder.get(i).width].setBlocked();
        	}
        }
		
        for (int i= EnemyQueenOrder.size()-1; i >= 0; i--) 
        {
        	queenKey= EnemyQueenOrder.get(i).width;
        	if (!MartyMcfly.EnemyQueens[queenKey].isBlocked())
        	{
        		adjacentCoordinates=MartyMcfly.EnemyQueens[queenKey].adjacentOpenPositions();
        		availableShots= MartyMcfly.masterboard.availableMovesFrom(moveVector[1].width,moveVector[1].height);   	
        		for (int j=0; j < availableShots.length; j++) 
        		{
        			if(adjacentCoordinates.contains(availableShots[j]))
        			{
        				System.out.println("megman");
        				MartyMcfly.masterboard.addarrow(availableShots[j].width, availableShots[j].height);
        				return availableShots[j];
        			}
        		}
        	}
        }
        
		// There were no direct shots we could make, so lets shoot where we were
        // This needs to be replaced with a function that determines a shot that
        // deals the most damage to the opponent and/or a shot that does the least damage to us
        MartyMcfly.masterboard.addarrow(moveVector[0].width, moveVector[0].height);
        return moveVector[0];
	}
	
	private LinkedList<Dimension> sortByOpenness(Queen[] queens)
	{
		//Ugh, unfortunately we need to sort our list of queens...
		// Too bad there isnt a better way...
		// For simplicity, we bubble sort
		LinkedList<Dimension> order= new LinkedList();
		int size, in, out;
		Dimension temp;

		for (int i=0; i<=3; i++) 
		{
			if(!queens[i].isBlocked()){
			order.add(new Dimension(i,queens[i].openness())); 
			}
		}

		size= order.size();
		if (size<= 1){ return order;}
		
		  for(out=size-1; out>1; out--)
			   for(in=0; in<out; in++) 

				  if( order.get(in).height > order.get(in+1).height ){
					  temp= order.get(in);
					  order.set(in, order.get(in+1));
					  order.set(in+1,temp);
				  }
 
		  return order;
	}

	private LinkedList<Dimension> sortByNeighbors(Queen[] queens){
		// For simplicity, we bubble sort
		LinkedList<Dimension> order= new LinkedList();
		int size, in, out;
		Dimension temp;

		for (int i=0; i<=3; i++) 
		{
			if(!queens[i].isBlocked())
			{
				order.add(new Dimension(i,queens[i].neighbors())); 
			}
		}

		size= order.size();
		if (size<= 1){ return order;}
		
		  for(out=size-1; out>1; out--)
			   for(in=0; in<out; in++) 
				  if( order.get(in).height > order.get(in+1).height )
				  {
					  temp= order.get(in);
					  order.set(in, order.get(in+1));
					  order.set(in+1,temp);
				  }
		  return order;
	}
	

// Check if any of our Queens are in immediate danger. If so, move them
// Check if any of their Queens are in immediate danger. If so take shot or move into pos for next turn shot
// Move our most endagered Queen into the most open area

// The above could be considered modes: Defense, Offense and Survival

	
	//Some thoughts: openness factor vs neighbors
}
