import java.awt.Dimension;
import java.util.LinkedList;

public class EnhancedBoard {
    public static short ARROW = -1;
    public static short START_LOC_VALUE = -2;
    public static short GOAL_LOC_VALUE = -3;
    public static short QUEENB = -4;
    public static short QUEENW = -5;   
    public static short TPATH = -6;    
    
    private int width = 10;
    private int height = 10;
    public Dimension startLoc = new Dimension();
    public Dimension goalLoc  = new Dimension();

    
    private short [][]theboard;
    
    public EnhancedBoard() {
        theboard = new short[width+2][height+2];
        for (int i=0; i<width+2; i++) {
            for (int j=0; j<height+2; j++) {
                theboard[i][j] = 0;
            }
        }
        for (int i=0; i<height+2; i++) {
            theboard[0][i] = theboard[width+1][i] = ARROW;
        }
        for (int i=0; i<width+2; i++) {
            theboard[i][0] = theboard[i][height+1] = ARROW;
        }
       
   
    }
    
	public void move(int Qx, int Qy, int Qx2, int Qy2){
		setpos(Qx2,Qy2, whatsat(Qx,Qy));
		setpos(Qx,Qy, (short)0);
	}   

	public void addarrow(int x, int y){
		setpos(x,y, ARROW);
	}
    
    public void setpathpoints(int x, int y, int x2, int y2){

         startLoc.width = x;
         startLoc.height = y;
         setpos(x, y, (short)-2);
        /**
         * Specify the goal location
         */
        goalLoc.width = x2;
        goalLoc.height = y2;
        setpos(x2, y2, GOAL_LOC_VALUE);    	
    }
    
	public int neighbors(int x, int y){
		int count=0;

		//Up Up
		if (whatsat(x,y-1) != 0){ count++;}
		//Down Down
		if (whatsat(x, y+1) != 0){ count++;}
		//Left right
		if (whatsat(x+1, y) != 0){ count++;}
		//Left right
		if (whatsat(x-1,y) != 0){ count++;}
		//AB AB Start
		if (whatsat(x-1,y-1) != 0){ count++;}
		if (whatsat(x+1,y+1) != 0){ count++;}
		if (whatsat(x+1,y-1) != 0){ count++;}
		if (whatsat(x-1,y+1) != 0){ count++;}
		return count;
	}

	public LinkedList<Dimension> getNeighbors(int x, int y){
		LinkedList<Dimension> neighborPositions = new LinkedList<Dimension>();

		//Up Up
		if (whatsat(x,y-1) != 0){ neighborPositions.add(new Dimension(x,y-1)); }
		//Down Down
		if (whatsat(x, y+1) != 0){ neighborPositions.add(new Dimension(x,y+1));}
		//Left right
		if (whatsat(x+1, y) != 0){ neighborPositions.add(new Dimension(x+1,y));}
		//Left right
		if (whatsat(x-1,y) != 0){ neighborPositions.add(new Dimension(x-1,y));}
		//AB AB Start
		if (whatsat(x-1,y-1) != 0){ neighborPositions.add(new Dimension(x-1,y-1));}
		if (whatsat(x+1,y+1) != 0){ neighborPositions.add(new Dimension(x+1,y+1));}
		if (whatsat(x+1,y-1) != 0){ neighborPositions.add(new Dimension(x+1,y-1));}
		if (whatsat(x-1,y+1) != 0){ neighborPositions.add(new Dimension(x-1,y+1));}
		return neighborPositions;
	}	

	public LinkedList<Dimension> getAdjacentOpenPositions(int x, int y){
		LinkedList<Dimension> adjacentPositions = new LinkedList<Dimension>();

		//Up Up
		if (whatsat(x,y-1) == 0){ adjacentPositions.add(new Dimension(x,y-1)); }
		//Down Down
		if (whatsat(x, y+1) == 0){ adjacentPositions.add(new Dimension(x,y+1));}
		//Left right
		if (whatsat(x+1, y) == 0){ adjacentPositions.add(new Dimension(x+1,y));}
		//Left right
		if (whatsat(x-1,y) == 0){ adjacentPositions.add(new Dimension(x-1,y));}
		//AB AB Start
		if (whatsat(x-1,y-1) == 0){ adjacentPositions.add(new Dimension(x-1,y-1));}
		if (whatsat(x+1,y+1) == 0){ adjacentPositions.add(new Dimension(x+1,y+1));}
		if (whatsat(x+1,y-1) == 0){ adjacentPositions.add(new Dimension(x+1,y-1));}
		if (whatsat(x-1,y+1) == 0){ adjacentPositions.add(new Dimension(x-1,y+1));}
		return adjacentPositions;
	}	
	
	
    
    public void printboard(){
		System.out.println("    0    1    2    3    4    5    6    7    8    9\n");
        for (int x=0; x<width; x++) {
        	System.out.print(x + "  ");
            for (int y=0; y<height; y++) {
                short val = whatsat(y,x);
                if ( val == ARROW) {
					System.out.print("AAA, ");
					
                } else if (val == START_LOC_VALUE) {
					System.out.print("_S_, ");
                	
                } else if (val == GOAL_LOC_VALUE) {
					System.out.print("_G_, ");
                } else if (val == QUEENW) {
					System.out.print("QW_, ");
                } else if (val == QUEENB) {
					System.out.print("QB_, ");
                } else if (val == TPATH) {
					System.out.print(" . , ");					
                }else{
                	System.out.print("___, ");
                }
    			
            }
            System.out.println();
        }
       
    }
    
    public Dimension[] availableMovesFrom(int originx, int originy){
    	Dimension [] ret = new Dimension[92]; // max possible moves
    	int count=0;
    	short val=0;
    		//x-
	        for (int x=1; x< 9; x++) {
	        	val=whatsat(originx-x, originy);
	        	if (val != ((short) 0)){
	        		break;
	        	}else{
	        	 ret[count]= new Dimension(originx-x, originy);
	        	 count++;
	        	}
	        }
	        // x+
	        for (int x=1; x< 9; x++) {
	        	val=whatsat(originx+x, originy);
	        	if (val != ((short) 0)){
	        		break;
	        	}else{
	        	 ret[count]= new Dimension(originx+x, originy);
	        	 count++;
	        	}
	        }	
	        // y-	        
	        for (int x=1; x< 9; x++) {
	        	val=whatsat(originx, originy-x);
	        	if (val != ((short) 0)){
	        		break;
	        	}else{
	        	 ret[count]= new Dimension(originx, originy-x);
	        	 count++;
	        	}
	        }	        
	        // y+	        
	        for (int x=1; x< 9; x++) {
	        	val=whatsat(originx, originy+x);
	        	if (val != ((short) 0)){
	        		break;
	        	}else{
	        	 ret[count]= new Dimension(originx, originy+x);
	        	 count++;
	        	}
	        }	 
	        //y+ x+
	        for (int x=1; x< 9; x++) {
	        	val=whatsat(originx+x, originy+x);
	        	if (val != ((short) 0)){
	        		break;
	        	}else{
	        	 ret[count]= new Dimension(originx+x, originy+x);
	        	 count++;
	        	}
	        }	 
	        //y- x-
	        for (int x=1; x< 9; x++) {
	        	val=whatsat(originx-x, originy-x);
	        	if (val != ((short) 0)){
	        		break;
	        	}else{
	        	 ret[count]= new Dimension(originx-x, originy-x);
	        	 count++;
	        	}
	        }		        

	        //x+ y-
	        for (int x=1; x< 9; x++) {
	        	val=whatsat(originx+x, originy-x);
	        	if (val != ((short) 0)){
	        		break;
	        	}else{
	        	 ret[count]= new Dimension(originx+x, originy-x);
	        	 count++;
	        	}
	        }	
	        //x- y+
	        for (int x=1; x< 9; x++) {
	        	val=whatsat(originx-x, originy+x);
	        	if (val != ((short) 0)){
	        		break;
	        	}else{
	        	 ret[count]= new Dimension(originx-x, originy+x);
	        	 count++;
	        	}
	        }

	     return (Dimension[]) resizeArray(ret, count);
    	
    }    

    private static Object resizeArray (Object oldArray, int newSize) {
    	   int oldSize = java.lang.reflect.Array.getLength(oldArray);
    	   Class elementType = oldArray.getClass().getComponentType();
    	   Object newArray = java.lang.reflect.Array.newInstance(
    	         elementType,newSize);
    	   int preserveLength = Math.min(oldSize,newSize);
    	   if (preserveLength > 0)
    	      System.arraycopy (oldArray,0,newArray,0,preserveLength);
    	   return newArray; }
    
    
    public int openness(int originx, int originy){
    	Dimension [] ret = new Dimension[92]; // max possible moves
    	int count=0;
    	short val=0;
    		//x-
	        for (int x=1; x< 9; x++) {
	        	val=whatsat(originx-x, originy);
	        	if (val != ((short) 0)){
	        		break;
	        	}else{
	        	 count++;

	        	}
	        }
	        // x+
	        for (int x=1; x< 9; x++) {
	        	val=whatsat(originx+x, originy);
	        	if (val != ((short) 0)){
	        		break;
	        	}else{
	        	count++;

	        	}
	        }	
	        // y-	        
	        for (int x=1; x< 9; x++) {
	        	val=whatsat(originx, originy-x);
	        	if (val != ((short) 0)){
	        		break;
	        	}else{
	        	count++;

	        	}
	        }	        
	        // y+	        
	        for (int x=1; x< 9; x++) {
	        	val=whatsat(originx, originy+x);
	        	if (val != ((short) 0)){
	        		break;
	        	}else{
	        	count++;
	        	}
	        }	 
	        //y+ x+
	        for (int x=1; x< 9; x++) {
	        	val=whatsat(originx+x, originy+x);
	        	if (val != ((short) 0)){
	        		break;
	        	}else{
	        	count++;
	        	}
	        }	 
	        //y- x-
	        for (int x=1; x< 9; x++) {
	        	val=whatsat(originx-x, originy-x);
	        	if (val != ((short) 0)){
	        		break;
	        	}else{
	        	count++;
	        	}
	        }		        

	        //x+ y-
	        for (int x=1; x< 9; x++) {
	        	val=whatsat(originx+x, originy-x);
	        	if (val != ((short) 0)){
	        		break;
	        	}else{
	        	count++;
	        	}
	        }	
	        //x- y+
	        for (int x=1; x< 9; x++) {
	        	val=whatsat(originx-x, originy+x);
	        	if (val != ((short) 0)){
	        		break;
	        	}else{
	        	count++;
	        	}
	        }
	     return count;
    	
    }        
    
    synchronized public short whatsat(int x, int y) { return theboard[x+1][y+1]; }
    synchronized public void setpos(int x, int y, short value) { theboard[x+1][y+1] = value; }
    public int getWidth() { return width; }
    public int getHeight() { return height; }
    
	public boolean blocked(int x, int y){
		if(whatsat(x,y) != 0){return false; }else{ return true;}
	}
}
