import java.awt.*;
import java.io.IOException;
import javax.swing.*;

public class MartyMcfly extends JPanel
{
	public static EnhancedBoard masterboard;
	public static Queen[] OurQueens= new Queen[4], EnemyQueens= new Queen[4];
	private Brain brain;
	private NetworkComm _netcom;
	private JFrame BoardFrame;
	boolean quitFlag=false;

	private Dimension[] outgoingMove;
	private Dimension outgoingShot;

    public MartyMcfly()
    {
    	super(new GridBagLayout());
    	
    	JFrame.setDefaultLookAndFeelDecorated(true);
    	BoardFrame = new JFrame("Amazons Game Consol");
		BoardFrame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    	
    	GridBagConstraints c = new GridBagConstraints();
    	
    	JButton _nextb = new nextButton();
		c.gridwidth = 1;
		c.gridheight = 1;
		c.gridx = 0;
		c.gridy = 0;
		c.fill = GridBagConstraints.NONE;
		c.insets = new Insets(10,10,10,10);
		add(_nextb, c);
		
		JButton _quitb = new quitButton();
		c.gridwidth = 1;
		c.gridheight = 1;
		c.gridx = 0;
		c.gridy = 1;
		c.fill = GridBagConstraints.NONE;
		c.insets = new Insets(10,10,10,10);
		add(_quitb, c);

    	this.setOpaque(true);
    	BoardFrame.setContentPane(this);
        BoardFrame.pack();
        BoardFrame.setVisible(false);
    }
    
    public void displayWindow(boolean state)
    {
    	BoardFrame.setVisible(state);
    }
    
    public void startTheGame(String usr, String psw, String opp)
    {
    	System.out.println("Game consol ready.");
    	System.out.println("Starting network communication...");
        _netcom = new NetworkComm(usr, psw, opp, this);
        System.out.println("Communication opened.");
        initBoard(_netcom.getColor());
        BoardFrame.setTitle("Game "+_netcom.getGameID()+". Player "+_netcom.getColor());
        getMoveMakeMove();
    }
    
    /*public void getMoveMakeMove()			//turn by turn version of game.
    {
    	try{
    	String readMessage;
    	readMessage = _netcom.readAndEcho(); //read in ?: or white move
    	
    	if(readMessage.charAt(0)=='R')	//check to make sure game is not finished
    	{	exitGame(readMessage); }

    	if (_netcom.getColor().equals("Black"))
    	{
    		recordEnemyMove(readMessage);
    		readMessage = _netcom.readAndEcho(); //need extra for query msg
    		if(readMessage.charAt(0)=='R')	//check to make sure game is not finished
        		{exitGame(readMessage);}
    	}
    		
    	outgoingMove= brain.calculateMove();	//start the AI to create a move
    	if (outgoingMove == null)
    	{
    		System.out.println("Marty.getMove: no move reported back. Game must be over. Waiting for results.");
    		_netcom.writeMessageAndEcho("(0:0):(0:0):(0:0)");
    		exitGame(_netcom.readAndEcho());
    	}
    	outgoingShot= brain.calculateShotFrom(outgoingMove);
    	sendMove(outgoingMove, outgoingShot);	//send our move to the server
    	
		readMessage = _netcom.readAndEcho();  // our move reported
		if(readMessage.charAt(0)=='R')	//check to make sure game is not finished
    		{exitGame(readMessage);}
		
		if (_netcom.getColor().equals("White"))
		{
			readMessage = _netcom.readAndEcho();  // enemey moves
			if(readMessage.charAt(0)=='R')	//check to make sure game is not finished
	    	{ exitGame(readMessage); }
			recordEnemyMove(readMessage);
		}
		
    	masterboard.printboard();
    	
    	} catch  (IOException e) {
    	    exitGame("IO Exception while in getMoveMakeMove!");
    	}
    }*/
    
    public void getMoveMakeMove()
    {
    	String readMessage = "Nothing happened in this game.";
    	while (quitFlag==false)
    	{
	    	try{
	    	readMessage = _netcom.readAndEcho(); //read in ?: or white move
	    	
	    	if(readMessage.charAt(0)=='R')	//check to make sure game is not finished
	    	{ break; }
	
	    	if (_netcom.getColor().equals("Black"))
	    	{
	    		recordEnemyMove(readMessage);
	    		readMessage = _netcom.readAndEcho(); //need extra for query msg
	    		if(readMessage.charAt(0)=='R')	//check to make sure game is not finished
	        		{break;}
	    	}
	    		
	    	outgoingMove= brain.calculateMove();	//start the AI to create a move
	    	if (outgoingMove == null)	//no more moves, must be loser. Sent nothing to server, wait for result
	    	{
	    		System.out.println("Marty.getMove: no move reported back. Game must be over. Waiting for results.");
	    		_netcom.writeMessageAndEcho("(0:0):(0:0):(0:0)");
	    		readMessage = _netcom.readAndEcho();
	    		break;
	    	}
	    	outgoingShot= brain.calculateShotFrom(outgoingMove);
	    	sendMove(outgoingMove, outgoingShot);	//send our move to the server
	    	
			readMessage = _netcom.readAndEcho();  // our move reported
			if(readMessage.charAt(0)=='R')	//check to make sure game is not finished
	    		{break;}
			
			if (_netcom.getColor().equals("White"))
			{
				readMessage = _netcom.readAndEcho();  // enemey moves
				if(readMessage.charAt(0)=='R')	//check to make sure game is not finished
		    	{ break; }
				recordEnemyMove(readMessage);
			}
			
	    	masterboard.printboard();
	    	
	    	} catch  (IOException e) {
	    	    exitGame("IO Exception while in getMoveMakeMove!");
	    	}
    	}
    	exitGame(readMessage);
    }
    
    public void sendMove(Dimension[] q, Dimension shot)
    {
    	String moveMsg = "("+q[0].height+":"+q[0].width+"):("+q.clone()[1].height+":"+q[1].width+"):("+shot.height+":"+shot.width+")";
    	System.out.println("Marty.SendMove: sending to netCom, "+moveMsg);
    	try {_netcom.writeMessageAndEcho(moveMsg);}
    	catch  (IOException e) {
    	    exitGame("IO Exception while trying to send move to server.\nCmd: "+moveMsg);
    	}
    }
    
    public void recordEnemyMove(String eMove)
    {
    	Dimension currQpos;
    	int sC = (int)eMove.charAt(12) - (int)'0';
    	int sR = (int)eMove.charAt(14) - (int)'0';;
    	
    	for (int i = 0; i<4;i++)
    	{
    		currQpos = EnemyQueens[i].getpos();
    		if ((currQpos.height == sC) && (currQpos.width == sR))
    		{
    			EnemyQueens[i].moveto(((int)eMove.charAt(20) - (int)'0'), ((int)eMove.charAt(18) - (int)'0'));
    			EnemyQueens[i].shoot(((int)eMove.charAt(26) - (int)'0'), ((int)eMove.charAt(24) - (int)'0'));
    			break;
    		}
    		System.out.println("Marty.recordEnemeyMove: Queen to move not found!");
    	}
    }

    private void initBoard(String color){
		masterboard = new EnhancedBoard();
		brain = new Brain();
		
		if(color.equals("White")){
			OurQueens[0]= new Queen(0,6);
			OurQueens[1]= new Queen(3,9);
			OurQueens[2]= new Queen(6,9);
			OurQueens[3]= new Queen(9,6);

			EnemyQueens[0]= new Queen(0,3);
			EnemyQueens[1]= new Queen(3,0);
			EnemyQueens[2]= new Queen(6,0);
			EnemyQueens[3]= new Queen(9,3);   		
		}else{
			EnemyQueens[0]= new Queen(0,6);
			EnemyQueens[1]= new Queen(3,9);
			EnemyQueens[2]= new Queen(6,9);
			EnemyQueens[3]= new Queen(9,6);

			OurQueens[0]= new Queen(0,3);
			OurQueens[1]= new Queen(3,0);
			OurQueens[2]= new Queen(6,0);
			OurQueens[3]= new Queen(9,3);      			
		}
        // Place Queens on board
		// -4 represents Black, -5 represents White
		masterboard.setpos(0, 3, (short)-4);
		masterboard.setpos(3, 0, (short)-4);
		masterboard.setpos(6, 0, (short)-4);
		masterboard.setpos(9, 3, (short)-4);

		masterboard.setpos(0, 6, (short)-5);
		masterboard.setpos(3, 9, (short)-5);
		masterboard.setpos(6, 9, (short)-5);
		masterboard.setpos(9, 6, (short)-5);
		
	}
    
    public void exitGame(String reason)
    {
    	quitFlag=true;
    	_netcom.endCommWithServer();
    	JOptionPane.showMessageDialog(BoardFrame,reason);
    	BoardFrame.dispose();
    }

    private class quitButton extends JButton implements java.awt.event.ActionListener
    {
    	public quitButton()
    	{
    		super("Quit Game");
    		addActionListener(this);
    	}
    	public void actionPerformed(java.awt.event.ActionEvent e)
    	{
    		exitGame("User Quit the Game");
    	}
    }
    private class nextButton extends JButton implements java.awt.event.ActionListener
    {
    	public nextButton()
    	{
    		super("Make next move");
    		addActionListener(this);
    			}
    			public void actionPerformed(java.awt.event.ActionEvent e)
    			{
    				getMoveMakeMove();
    			}
    		}
	}