import java.awt.Dimension;
import java.util.LinkedList;

public class Queen {
	private int x, y;
	private boolean blocked= false; // Permenantly blocked by arrows and/or boundaries
	private BFS currentSearchEngine = null;
	private LinkedList<Dimension> moveQueue= new LinkedList();
	
	public Queen(int newx, int newy)
	{
		x=newx;
		y=newy;
		
	}

	public void moveto(int newx, int newy){
		MartyMcfly.masterboard.move(x,y,newx, newy);

		x = newx;
		y = newy;
	}
	public void shoot(int destx, int desty){

		MartyMcfly.masterboard.addarrow(destx, desty);
	}	
	
	public void setBlocked(){
		blocked=true;
	}
	public boolean isBlocked(){
		return blocked;
	}
	
	public void queueMove(Dimension pos){
		moveQueue.addFirst(pos);
	}
	public Dimension getMoveFromQueue(){
		return moveQueue.remove();
	}
	
	
	public void splitPath(Dimension[] path){
		// If I had to code one function before I died... it would _not_ be this one
		
		int direction= directionFinder(path[0].width, path[0].height, path[1].width, path[1].height );
		int nextdirection;
		
        for (int i=1; i< (path.length-1); i++) {
            nextdirection= directionFinder(path[i].width, path[i].height, path[i+1].width, path[i+1].height);
            
            if (direction != nextdirection){       	
            queueMove(path[i]);
            direction= nextdirection; 
            }
        }            
      
		
	}
	
	public int directionFinder(int originx,int originy,int destx,int desty){
		//North: 0
		//East: 1
		//South: 2
		//West:3
		//NE:4
		//SE:5
		//SW:6
		//NW:7
		
		if(originx == destx && originy < desty){ return 2;}
		if(originx == destx && originy > desty){ return 0;}
		if(originx < destx && originy == desty){ return 1;}
		if(originx > destx && originy == desty){ return 3;}
		
		if(originx < destx && originy < desty){ return 5;}
		if(originx > destx && originy > desty){ return 7;}
		if(originx > destx && originy < desty){ return 4;}
		if(originx < destx && originy > desty){ return 3;}

        System.out.println("ERROR IN DIRECTION FINDER!");
		return -1;
	}
	
	public Dimension getBestMove(){
		Dimension[] moves = availableMoves();
		Dimension bestmove = null;
		int bestOpenness =0;
		
		//Weird Fix look into this
		
		if(moves.length == 1){
			
			return new Dimension(moves[0].width,moves[0].height);
		}
		
		for (int i=0; i< (moves.length); i++) {
			if (MartyMcfly.masterboard.openness(moves[i].width, moves[i].height) > bestOpenness){
				bestOpenness= MartyMcfly.masterboard.openness(moves[i].width, moves[i].height);
				bestmove = new Dimension(moves[i].width,moves[i].height);
			}
		
		}
		// Moving into spot with 0 emptiness
		if (bestmove == null){bestmove = new Dimension(moves[0].width,moves[0].height);}

		return bestmove;		
		
	}
	
	
	public Dimension getpos(){
		return new Dimension(x,y);
	}

	public int neighbors(){
		return MartyMcfly.masterboard.neighbors(x, y);
	}
	
	public LinkedList<Dimension> getNeighbors(){
		return MartyMcfly.masterboard.getNeighbors(x, y);
	}
	
	public LinkedList<Dimension> adjacentOpenPositions(){
		return MartyMcfly.masterboard.getAdjacentOpenPositions(x, y);
	}	
	
	public Dimension[] availableMoves(){
		return	MartyMcfly.masterboard.availableMovesFrom(x, y);
	}

	
	public int openness(){
		return	MartyMcfly.masterboard.openness(x, y);
	}	
	public Dimension[] getpathto(int destx, int desty){
		currentSearchEngine = new BFS(MartyMcfly.masterboard, x,y,destx,desty);
		return currentSearchEngine.getPath();
	}
	
}
