import java.awt.Dimension;

public class SearchEngine {
    public SearchEngine(EnhancedBoard board,int x,int y,int x2, int y2) {
        theboard = board;
        theboard.setpathpoints(x, y, x2, y2);
        initSearch();
    }
    public EnhancedBoard getMaze() { return theboard; }
    protected EnhancedBoard theboard;
    protected Dimension [] searchPath = null;
    protected int pathCount;
    protected int maxDepth;
    protected Dimension startLoc, goalLoc, currentLoc;
    protected boolean isSearching = true;

    protected void initSearch() {
        if (searchPath == null) {
            searchPath = new Dimension[1000];
            for (int i=0; i<1000; i++) {
                searchPath[i] = new Dimension();
            }
        }
        pathCount = 0;
        startLoc = theboard.startLoc;
        currentLoc = startLoc;
        goalLoc = theboard.goalLoc;
        searchPath[pathCount++] = currentLoc;
    }
    
    protected boolean equals(Dimension d1, Dimension d2) {
        return d1.getWidth() == d2.getWidth() && d1.getHeight() == d2.getHeight();
    }

    public Dimension [] getPath() {
      Dimension [] ret = new Dimension[maxDepth];
      for (int i=0; i<maxDepth; i++) {
        ret[i] = searchPath[i];
      }
      return ret;
    }
    
    

    
    protected Dimension [] getAdjacentMoves(Dimension loc) {
        Dimension tempMoves [] = new Dimension[8];
        tempMoves[0] = tempMoves[1] = tempMoves[2] = tempMoves[3] = tempMoves[4] = tempMoves[5] = tempMoves[6] = tempMoves[7] =null;
        int x = loc.width;
        int y = loc.height;
        int num = 0;
        if (theboard.whatsat(x - 1, y) == 0 || theboard.whatsat(x - 1, y) == EnhancedBoard.GOAL_LOC_VALUE) {
            tempMoves[num++] = new Dimension(x - 1, y);
        }
        if (theboard.whatsat(x + 1, y) == 0 || theboard.whatsat(x + 1, y) == EnhancedBoard.GOAL_LOC_VALUE) {
            tempMoves[num++] = new Dimension(x + 1, y);
        }
        if (theboard.whatsat(x, y - 1) == 0 || theboard.whatsat(x, y - 1) == EnhancedBoard.GOAL_LOC_VALUE) {
            tempMoves[num++] = new Dimension(x, y - 1);
        }
        if (theboard.whatsat(x, y + 1) == 0 || theboard.whatsat(x, y + 1) == EnhancedBoard.GOAL_LOC_VALUE) {
            tempMoves[num++] = new Dimension(x, y + 1);
        }
        
        
        if (theboard.whatsat(x-1, y-1) == 0 || theboard.whatsat(x-1, y-1) == EnhancedBoard.GOAL_LOC_VALUE) {
            tempMoves[num++] = new Dimension(x-1, y-1);
        }
        if (theboard.whatsat(x+1, y+1) == 0 || theboard.whatsat(x+1, y+1) == EnhancedBoard.GOAL_LOC_VALUE) {
            tempMoves[num++] = new Dimension(x+1, y+1);
        }
        if (theboard.whatsat(x+1, y-1) == 0 || theboard.whatsat(x+1, y-1) == EnhancedBoard.GOAL_LOC_VALUE) {
            tempMoves[num++] = new Dimension(x+1, y-1);
        }
        if (theboard.whatsat(x-1, y+1) == 0 || theboard.whatsat(x-1, y+1) == EnhancedBoard.GOAL_LOC_VALUE) {
            tempMoves[num++] = new Dimension(x-1, y+1);
        }        
        
        
        return tempMoves;
    }
}
